# Class JavaDocRegion

java.lang.Object
org.eclipse.jdt.core.dom.ASTNode
org.eclipse.jdt.core.dom.AbstractTagElement
org.eclipse.jdt.core.dom.JavaDocRegion

All Implemented Interfaces:
  `IDocElement`

public class JavaDocRegion extends AbstractTagElement
JavaDocRegion pattern AST node type.

    JavaDocRegion:
        [ TagElement { , TagElement } ]
        [ ASTNode { [TextElement] [JavaDocRegion] } ]
        validSnippet

Since:
  3.30

## Field Summary

Fields
Modifier and Type
Field
Description
`static final SimplePropertyDescriptor`
`DUMMY_REGION_PROPERTY`
The "dummy regions" structural property of this node type (added in JEP 413).
`static final ChildListPropertyDescriptor`
`FRAGMENTS_PROPERTY`
The "fragments" structural property of this node type (element type: `IDocElement`).
`static final SimplePropertyDescriptor`
`TAG_NAME_PROPERTY`
The "tagName" structural property of this node type (type: `String`).
`static final ChildListPropertyDescriptor`
`TAGS_PROPERTY`
The "tags" structural property of this node type (child type: `TagElement`).
`static final SimplePropertyDescriptor`
`VALID_SNIPPET_PROPERTY`
The "validSnippet" structural property of this node type (added in JEP 413).

### Fields inherited from class ASTNode

`ANNOTATION_TYPE_DECLARATION, ANNOTATION_TYPE_MEMBER_DECLARATION, ANONYMOUS_CLASS_DECLARATION, ARRAY_ACCESS, ARRAY_CREATION, ARRAY_INITIALIZER, ARRAY_TYPE, ASSERT_STATEMENT, ASSIGNMENT, BLOCK, BLOCK_COMMENT, BOOLEAN_LITERAL, BREAK_STATEMENT, CASE_DEFAULT_EXPRESSION, CAST_EXPRESSION, CATCH_CLAUSE, CHARACTER_LITERAL, CLASS_INSTANCE_CREATION, COMPILATION_UNIT, CONDITIONAL_EXPRESSION, CONSTRUCTOR_INVOCATION, CONTINUE_STATEMENT, CREATION_REFERENCE, DIMENSION, DO_STATEMENT, EitherOr_MultiPattern, EMPTY_STATEMENT, ENHANCED_FOR_STATEMENT, ENUM_CONSTANT_DECLARATION, ENUM_DECLARATION, EXPORTS_DIRECTIVE, EXPRESSION_METHOD_REFERENCE, EXPRESSION_STATEMENT, FIELD_ACCESS, FIELD_DECLARATION, FOR_STATEMENT, GUARDED_PATTERN, IF_STATEMENT, IMPORT_DECLARATION, INFIX_EXPRESSION, INITIALIZER, INSTANCEOF_EXPRESSION, INTERSECTION_TYPE, JAVADOC, JAVADOC_REGION, JAVADOC_TEXT_ELEMENT, LABELED_STATEMENT, LAMBDA_EXPRESSION, LINE_COMMENT, MALFORMED, MARKER_ANNOTATION, MEMBER_REF, MEMBER_VALUE_PAIR, METHOD_DECLARATION, METHOD_INVOCATION, METHOD_REF, METHOD_REF_PARAMETER, MODIFIER, MODULE_DECLARATION, MODULE_MODIFIER, MODULE_QUALIFIED_NAME, NAME_QUALIFIED_TYPE, NORMAL_ANNOTATION, NULL_LITERAL, NULL_PATTERN, NUMBER_LITERAL, OPENS_DIRECTIVE, ORIGINAL, PACKAGE_DECLARATION, PARAMETERIZED_TYPE, PARENTHESIZED_EXPRESSION, PATTERN_INSTANCEOF_EXPRESSION, POSTFIX_EXPRESSION, PREFIX_EXPRESSION, PRIMITIVE_TYPE, PROTECT, PROVIDES_DIRECTIVE, QUALIFIED_NAME, QUALIFIED_TYPE, RECORD_DECLARATION, RECORD_PATTERN, RECOVERED, REQUIRES_DIRECTIVE, RETURN_STATEMENT, SIMPLE_NAME, SIMPLE_TYPE, SINGLE_MEMBER_ANNOTATION, SINGLE_VARIABLE_DECLARATION, STRING_LITERAL, SUPER_CONSTRUCTOR_INVOCATION, SUPER_FIELD_ACCESS, SUPER_METHOD_INVOCATION, SUPER_METHOD_REFERENCE, SWITCH_CASE, SWITCH_EXPRESSION, SWITCH_STATEMENT, SYNCHRONIZED_STATEMENT, TAG_ELEMENT, TAG_PROPERTY, TEXT_BLOCK, TEXT_ELEMENT, THIS_EXPRESSION, THROW_STATEMENT, TRY_STATEMENT, TYPE_DECLARATION, TYPE_DECLARATION_STATEMENT, TYPE_LITERAL, TYPE_METHOD_REFERENCE, TYPE_PARAMETER, TYPE_PATTERN, UNION_TYPE, UNNAMED_CLASS, USES_DIRECTIVE, VARIABLE_DECLARATION_EXPRESSION, VARIABLE_DECLARATION_FRAGMENT, VARIABLE_DECLARATION_STATEMENT, WHILE_STATEMENT, WILDCARD_TYPE, YIELD_STATEMENT`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`isDummyRegion()`
Returns `true` is region is dummy else `false`.
`boolean`
`isValidSnippet()`
Returns `true` if region has valid snippet else `false`.
`static List`
`propertyDescriptors(int apiLevel)`
Returns a list of structural property descriptors for this node type.
`void`
`setDummyRegion(boolean dummyRegion)`
Sets the value of dummyRegion property.
`void`
`setValidSnippet(boolean validSnippet)`
Sets the value of validSnippet property.
`List`
`tags()`
Returns the list of tag elements in this region, or `empty` if there is none.

### Methods inherited from class AbstractTagElement

`fragments, getTagName, getTagNameProperty, internalTagNamePropertyFactory, isNested, setTagName`

### Methods inherited from class ASTNode

`accept, copySubtree, copySubtrees, delete, equals, getAST, getFlags, getLength, getLocationInParent, getNodeType, getParent, getProperty, getRoot, getStartPosition, getStructuralProperty, hashCode, nodeClassForType, properties, setFlags, setProperty, setSourceRange, setStructuralProperty, structuralPropertiesForType, subtreeBytes, subtreeMatch, toString`

### Methods inherited from class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### TAG_NAME_PROPERTY

public static final SimplePropertyDescriptor TAG_NAME_PROPERTY
The "tagName" structural property of this node type (type: `String`).

### FRAGMENTS_PROPERTY

public static final ChildListPropertyDescriptor FRAGMENTS_PROPERTY
The "fragments" structural property of this node type (element type: `IDocElement`). These are the containers which will have texts and other JavaDoc regions

### TAGS_PROPERTY

public static final ChildListPropertyDescriptor TAGS_PROPERTY
The "tags" structural property of this node type (child type: `TagElement`). (added in JEP 413). These are the decorators like link, highlight etc

### DUMMY_REGION_PROPERTY

public static final SimplePropertyDescriptor DUMMY_REGION_PROPERTY
The "dummy regions" structural property of this node type (added in JEP 413).

### VALID_SNIPPET_PROPERTY

public static final SimplePropertyDescriptor VALID_SNIPPET_PROPERTY
The "validSnippet" structural property of this node type (added in JEP 413).

## Method Details

### propertyDescriptors

public static List propertyDescriptors(int apiLevel)
Returns a list of structural property descriptors for this node type. Clients must not modify the result.

Parameters:
  `apiLevel` - the API level; one of the `AST.JLS*` constants
Returns:
  a list of property descriptors (element type: `StructuralPropertyDescriptor`)

### tags

public List tags()
Returns the list of tag elements in this region, or `empty` if there is none.

Returns:
  the list of tag element nodes (element type: `TagElement`)
Throws:
  `UnsupportedOperationException` - if this operation is used below JLS18

### isDummyRegion

public boolean isDummyRegion()
Returns `true` is region is dummy else `false`.

Returns:
  the dummyRegion
Throws:
  `UnsupportedOperationException` - if this operation is used below JLS18

### setDummyRegion

public void setDummyRegion(boolean dummyRegion)
Sets the value of dummyRegion property.

Throws:
  `UnsupportedOperationException` - if this operation is used below JLS18

### isValidSnippet

public boolean isValidSnippet()
Returns `true` if region has valid snippet else `false`.

Returns:
  the validSnippet
Throws:
  `UnsupportedOperationException` - if this operation is used below JLS18

### setValidSnippet

public void setValidSnippet(boolean validSnippet)
Sets the value of validSnippet property.

Throws:
  `UnsupportedOperationException` - if this operation is used below JLS18